local HitImpact = function(attacker, tr, dmginfo)

	local hit = EffectData()
	hit:SetOrigin(tr.HitPos)
	hit:SetNormal(tr.HitNormal)
	hit:SetScale(20)
	util.Effect("effect_hit", hit)

	return true
end
if (SERVER) then
AddCSLuaFile( "shared.lua" )
SWEP.HoldType = "pistol"
end

if (CLIENT) then
SWEP.DrawCrosshair = false
SWEP.Slot = 3
SWEP.ViewModelFOV = 60
SWEP.ViewModelFlip = false
SWEP.DrawAmmo			= true
end
SWEP.Author			= "Azazel"
SWEP.Contact		= "nope"
SWEP.Purpose		= "Kill EveryBody"
SWEP.Instructions	= "Press M1 to shoot ..."
SWEP.Spawnable 			= true
SWEP.AdminSpawnable 		= true
SWEP.Slot               = 3
SWEP.SlotPos            = 8
SWEP.Category           = "L4D2"
SWEP.PrintName          = "Dual Pistol"
SWEP.ViewModel 			= "models/v_models/v_dual_pistola.mdl"
SWEP.WorldModel 			= "models/weapons/w_pistol.mdl"
SWEP.IconLetter 		= "q"
if (CLIENT) then
surface.CreateFont( "csd", ScreenScale( 30 ), 500, true, true, "CSKillIcons" )
	surface.CreateFont( "csd", ScreenScale( 60 ), 500, true, true, "CSSelectIcons" )
end
// Note: This is how it should have worked. The base weapon would set the category
// all of the children would have inherited that.
// But a lot of SWEPS have based themselves on this base (probably not on purpose)
// So the category name is now defined in all of the child SWEPS.
SWEP.FiresUnderwater 		= false
SWEP.Primary.Sound			= Sound( "weapons/pistol/pistol_fire.wav" )
SWEP.Primary.Damage			= 15
SWEP.Primary.NumShots		= 1
SWEP.Primary.Delay			= 0.19
SWEP.Primary.ClipSize		= 40
SWEP.Primary.DefaultClip	= 150
SWEP.Primary.Automatic      = false
SWEP.Primary.Ammo			= "smg1"
SWEP.ShowCrossHair          = true
SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic	= false
SWEP.Secondary.Ammo			= "none"
SWEP.ShellEffect          = "RifleShell"
SWEP.CrouchModifier		= 0.7
SWEP.IronSightModifier 	= 0.7
SWEP.RunModifier 		= 1.5
SWEP.JumpModifier 		= 1.5
SWEP.MinRecoil			= 0.1
SWEP.MaxRecoil			= 0.3
SWEP.DeltaRecoil		= 0.05

SWEP.RecoverTime 		= 0.8
SWEP.MinSpread			= 0.001
SWEP.MaxSpread			= 0.08
SWEP.DeltaSpread		= 0.003

SWEP.MinSpray			= 0.2
SWEP.MaxSpray			= 0.65
SWEP.DeltaSpray			= 0.2
SWEP.CrossHairScale     = 0.03
mode = 1
/*---------------------------------------------------------
---------------------------------------------------------*/
function SWEP:Initialize()

	if ( SERVER ) then
		self:SetWeaponHoldType( self.HoldType )
		self:SetNPCMinBurst( 30 )
		self:SetNPCMaxBurst( 30 )
		self:SetNPCFireRate( 0.01 )
	end
	local clip = self.Weapon:Clip1()
	self:ResetVars()
	end


/*---------------------------------------------------------
	Reload does nothing
---------------------------------------------------------*/
function SWEP:Reload()
	if (SERVER) then
	self.Owner:SetFOV( 0, 0.15 )
	self.Owner:DrawViewModel(true)
	end
	self.Weapon:DefaultReload( ACT_VM_RELOAD );
	timer.Simple(0.4, function()
	self.Weapon:EmitSound("weapons/pistol/gunother/pistol_clip_out_1.wav" )
	end)
	timer.Simple(0.98, function()
	self.Weapon:EmitSound("weapons/pistol/gunother/pistol_clip_in_1.wav" )
	end)
	timer.Simple(1.7, function()
	self.Weapon:EmitSound("weapons/pistol/gunother/pistol_clip_in_1.wav" )
	end)
end

/*---------------------------------------------------------
	PrimaryAttack
---------------------------------------------------------*/
function SWEP:vmodel()
if (CLIENT) then
self.v_model = ClientsideModel("models/weapons/arms/v_arms_gambler_new.mdl")
local vm = self.Owner:GetViewModel()
self.v_model:SetPos(vm:GetPos())
self.v_model:SetAngles(vm:GetAngles())
self.v_model:AddEffects(EF_BONEMERGE)
self.v_model:SetNoDraw(true)
self.v_model:SetParent(vm)
end
end

function SWEP:ViewModelDrawn()
if (CLIENT) then
if not self.v_model then self:vmodel() end
if self.v_model then self.v_model:DrawModel() end
end
end

function SWEP:PrimaryAttack()
	local clip = self.Weapon:Clip1()
	if not self:CanFire(clip) then return end
	if mode == 1 then
	self.Weapon:SendWeaponAnim(ACT_VM_PRIMARYATTACK) 
self.Weapon:SetNextPrimaryFire( CurTime() + self.Primary.Delay )
self.Weapon:EmitSound( "weapons/pistol/pistol_fire.wav" )
	self:BaseAttack()
mode = 2
elseif mode == 2 then
	self.Weapon:SendWeaponAnim(ACT_VM_SECONDARYATTACK) 
self.Weapon:SetNextPrimaryFire( CurTime() + self.Primary.Delay )
self.Weapon:EmitSound( "weapons/pistol/pistol_dual_fire.wav" )
	self:BaseAttack()
	mode = 1
end
end

/*---------------------------------------------------------
	Checks the objects before any action is taken
	This is to make sure that the entities haven't been removed
---------------------------------------------------------*/
function SWEP:DrawWeaponSelection( x, y, wide, tall, alpha )
	
	draw.SimpleText( self.IconLetter, "CSSelectIcons", x + wide/2, y + tall*0.2, Color( 255, 210, 0, 255 ), TEXT_ALIGN_CENTER )
	
	// try to fool them into thinking they're playing a Tony Hawks game
	draw.SimpleText( self.IconLetter, "CSSelectIcons", x + wide/2 + math.Rand(-4, 4), y + tall*0.2+ math.Rand(-14, 14), Color( 255, 210, 0, math.Rand(10, 120) ), TEXT_ALIGN_CENTER )
	draw.SimpleText( self.IconLetter, "CSSelectIcons", x + wide/2 + math.Rand(-4, 4), y + tall*0.2+ math.Rand(-9, 9), Color( 255, 210, 0, math.Rand(10, 120) ), TEXT_ALIGN_CENTER )
	
end
function SWEP:SetIronsights( b )
	self.Weapon:SetNetworkedBool( "Ironsights", b )

end

SWEP.NextSecondaryAttack = 0
/*---------------------------------------------------------
	SecondaryAttack
---------------------------------------------------------*/
function SWEP:SecondaryAttack()
end
/*---------------------------------------------------------
	DrawHUD
	
	Just a rough mock up showing how to draw your own crosshair.
	
---------------------------------------------------------*/
function SWEP:DrawHUD()
	// No crosshair when ironsights is on
	if ( self.Weapon:GetNetworkedBool( "Ironsights" ) ) or self.ShowCrossHair == false then return end

	local x = ScrW() / 2.0
	local y = ScrH() / 2.0
	local scale = 10 * self.CrossHairScale
	if self.Owner:KeyDown(IN_SPEED) and self.Owner:GetVelocity():Length() != 0 then
		scale = self.CrossHairScale * 20
	elseif self.Owner:KeyDown(IN_FORWARD) or self.Owner:KeyDown(IN_BACK) or self.Owner:KeyDown(IN_MOVELEFT) or self.Owner:KeyDown(IN_MOVERIGHT) then
		scale = self.CrossHairScale * 15
	elseif self.Owner:KeyDown(IN_DUCK) or self.Owner:KeyDown(IN_WALK) then
		scale = math.Clamp( self.CrossHairScale*10 / 2, 0, 100 )
	end
	
	// Scale the size of the crosshair according to how long ago we fired our weapon
	local LastShootTime = self.Weapon:GetNetworkedFloat( "LastShootTime", 0 )
	scale = scale * (2 - math.Clamp( (CurTime() - LastShootTime) * 5, 0.0, 1.0 ))
	
	surface.SetDrawColor( 0, 255, 0, 255 ) 
	// Draw an awesome crosshair
	local gap = 40 * scale
	local length = gap + 20 * scale
	surface.DrawLine( x - length, y, x - gap, y )
	surface.DrawLine( x + length, y, x + gap, y )
	surface.DrawLine( x, y - length, x, y - gap )
	surface.DrawLine( x, y + length, x, y + gap )
end

/*---------------------------------------------------------
	onRestore
	Loaded a saved game (or changelevel)
---------------------------------------------------------*/
function SWEP:OnRestore()

	self.NextSecondaryAttack = 0
	self:SetIronsights( false )
	
end
function SWEP:CanFire(clip)

	if not self.Weapon or not self.Owner or not (self.OwnerIsNPC or self.Owner:Alive()) then return end

	if clip <= 0 or (self.Owner:WaterLevel() >= 3 and not self.FiresUnderwater) then
	
		self.Weapon:EmitSound("Weapon_Pistol.Empty")
		self.Weapon:SetNextPrimaryFire(CurTime() + 0.2)
		return false -- Note that we don't automatically reload.  The player has to do this manually.
		
	end
	
	return true

end
--Fire modes init

function SWEP:Think()
end

function SWEP:Deploy()
self.Weapon:SendWeaponAnim( ACT_VM_DEPLOY )
self.Weapon:EmitSound("weapons/pistol/gunother/pistol_deploy_1.wav")
end

function SWEP:ResetVars()

	self.NextSecondaryAttack = 0
	
	self.CurrentSpread = self.MinSpread
	self.CurrentRecoil	= self.MinRecoil
	self.CurrentSpray 	= self.MinSpray
	self.SprayVec 		= Vector(0,0,0)
	self.bLastIron = false

	
	if self.Owner then
		self.OwnerIsNPC = self.Owner:IsNPC() -- This ought to be better than getting it every time we fire
		self:SetIronsights(false,self.Owner)
	end
	
end

-- We need to call ResetVars() on these functions so we don't whip out a weapon with scope mode or insane recoil right of the bat or whatnot
function SWEP:Holster(wep)	    self:ResetVars() return true end
function SWEP:Equip(NewOwner) 	self:ResetVars() return true end
function SWEP:OnRemove() 		self:ResetVars() return true end
function SWEP:OnDrop() 			self:ResetVars() return true end
function SWEP:OwnerChanged() 	self:ResetVars() return true end
function SWEP:OnRestore() 		self:ResetVars() return true end


---------------------------------------------------------
----------Attack Helper Functions----------------
---------------------------------------------------------

-- Generic attack function
SWEP.LastAttack = CurTime()
SWEP.LastDeltaSprayVec = Vector(0,0,0)
function SWEP:BaseAttack()
	if not self:CanFire(self.Weapon:Clip1()) then return end
	self.Weapon:SetNetworkedFloat( "LastShootTime", CurTime() )
	-- Calculate recover (cool down) scale
	local fCurTime = CurTime()
	local DeltaTime = fCurTime - self.LastAttack
	local RecoverScale = (1 - DeltaTime/1)
	self.LastAttack = fCurTime
	
	-- Apply cool-down to spread, spray, and recoil
	self.CurrentSpread = math.Clamp(self.CurrentSpread*RecoverScale, self.MinSpread, self.MaxSpread)
	self.CurrentRecoil = math.Clamp(self.CurrentRecoil*RecoverScale, self.MinRecoil, self.MaxRecoil)
	self.CurrentSpray = math.Clamp(self.CurrentSpray*RecoverScale, self.MinSpray, self.MaxSpray)
	self.SprayVec = self.SprayVec*((self.CurrentSpray - self.MinSpray)/(self.MaxSpray - self.MinSpray))
	
	-- Calculate modifiers/take ammo
	local modifier = 1
	if not self.OwnerIsNPC then -- NPCs don't get modifiers
	
		modifier = self:CalculateModifiers(self.RunModifier,self.CrouchModifier,self.JumpModifier,self.IronSightModifier)
		self:TakePrimaryAmmo(1) -- NPCs get infinate ammo, as they don't know how to reload
		
	end
	local NewSpray 		= self.CurrentSpray*modifier
	
	-- Fire the bullets
	self:FireBullet(	self.Primary.Damage, 
						self.NonIronsightCone, 
						self.CurrentSpread*modifier, 
						NewSpray, 
						self.SprayVec)

	-- Apply recoil and spray
	self:ApplyRecoil(self.CurrentRecoil*modifier,NewSpray)

	-- Update spread, spray, and recoil
	self.CurrentRecoil 	= math.Clamp(self.CurrentRecoil + self.DeltaRecoil, self.MinRecoil, self.MaxRecoil)
	self.CurrentSpread 	= math.Clamp(self.CurrentSpread + self.DeltaSpread, self.MinSpread, self.MaxSpread)
	self.CurrentSpray 	= math.Clamp(self.CurrentSpray + self.DeltaSpray, self.MinSpray, self.MaxSpray)
	
	local DeltaSprayVec = VectorRand()*0.02 -- Change in spray vector
	self.SprayVec = self.SprayVec + DeltaSprayVec + self.LastDeltaSprayVec -- This "smooths out" the motion of the spray vector
	self.LastDeltaSprayVec = DeltaSprayVec

	-- Shoot Effects
	self:ShootEffects()

end

function SWEP:ShootEffects()

	local PlayerPos = self.Owner:GetShootPos()
	local PlayerAim = self.Owner:GetAimVector()
		-- View model animation
	self.Owner:MuzzleFlash()								-- Crappy muzzle light
	self.Owner:SetAnimation(PLAYER_ATTACK1)					-- 3rd Person Animation			
	
end

function SWEP:CalculateModifiers(run,crouch,jump,iron)

	local modifier = 1

	if self.Owner:KeyDown(IN_FORWARD | IN_BACK | IN_MOVELEFT | IN_MOVERIGHT) then
		modifier = modifier*run
	end
	
	if self.Weapon:GetNetworkedBool("Ironsights", false) then 
		modifier = modifier*iron
	end
	
	if not self.Owner:IsOnGround() then
		return modifier*jump --You can't be jumping and crouching at the same time, so return here
	end
	
	if self.Owner:Crouching() then 
		modifier = modifier*crouch
	end
	
	return modifier

end

function SWEP:ApplyRecoil(recoil,spray)
self.OwnerIsNPC = self.Owner:IsNPC()
	if self.OwnerIsNPC or (SERVER and not self.Owner:IsListenServerHost()) then return end
	
	local EyeAng = Angle(
	recoil*math.Rand(-1,-0.7 + spray*0.4) + spray*math.Rand(-0.3,0.3), -- Up/Down recoil
	recoil*math.Rand(-0.4,0.4) + spray*math.Rand(-0.4,0.4), -- Left/Right recoil
	0)
	
	-- Punch the player's view
	self.Owner:ViewPunch(1.3*EyeAng) -- This smooths out the player's screen movement when recoil is applied
	self.Owner:SetEyeAngles(self.Owner:EyeAngles() + EyeAng)
	end
	
	function SWEP:FireBullet(dmg, speed, spread, spray, sprayvec, numbul)

	local PlayerAim = self.Owner:GetAimVector()
	local PlayerPos = self.Owner:GetShootPos()
	
	numbul = numbul or 1
	
	local bullet = {}
	bullet.Num		= numbul
	bullet.Src		= PlayerPos
	bullet.Dir		= (PlayerAim + 0.04*spray*sprayvec:GetNormalized()):GetNormalized()
	bullet.Spread	= Vector(spread, spread, 0)
	bullet.Force	= 0.15*dmg
	bullet.Damage	= dmg
	bullet.Tracer	= 0
	bullet.Callback 	= HitImpact
	self.Owner:FireBullets( bullet )

end
